import { expect } from 'chai';
import { NullLogger } from 'noicejs';

import { catchAndLog } from '../../src/utils/async.js';

describe('async utils', () => {
  describe('catch and log', () => {
    it('should catch and log errors', async () => {
      async function fail() {
        throw new Error('fail');
      }

      expect(() => catchAndLog(fail(), NullLogger.global, 'catch the failure')).not.to.throw();
    });

    it('should not return values', async () => {
      const value = 1;
      async function pass() {
        return value;
      }

      expect(catchAndLog(pass(), NullLogger.global, 'catch the failure')).not.to.equal(value);
    });
  });
});
